/*********************** dSPACE target specific file *************************

   Include file AnsteuerungAchse_rti.c:

   Definition of functions and variables for the system I/O and for
   the hardware and software interrupts used.

   RTI1104 7.0 (02-May-2013)
   Tue Dec 17 17:32:42 2013

   (c) Copyright 2006, dSPACE GmbH. All rights reserved.

 *****************************************************************************/

#if !(defined(__RTI_SIMENGINE__) || defined(RTIMP_FRAME))
# error This file may be included only by the RTI(-MP) simulation engine.
#endif

/* Include the model header file. */
#include "AnsteuerungAchse.h"
#include "AnsteuerungAchse_private.h"

/* Defines for block output and parameter structure existence */
#define RTI_rtB_STRUCTURE_EXISTS       1
#define RTI_rtP_STRUCTURE_EXISTS       1
#define RTB_STRUCTURE_NAME             AnsteuerungAchse_B
#define RTP_STRUCTURE_NAME             AnsteuerungAchse_P

/* dSPACE generated includes for header files */
#include <brtenv.h>
#include <rtkernel.h>
#include <rti_assert.h>
#include <rtidefineddatatypes.h>
#include <dsser.h>

/****** Definitions: task functions for timer tasks *********************/

/* Timer Task 1. (Base rate). */
static void rti_TIMERA(rtk_p_task_control_block task)
{
  /* Task entry code BEGIN */
  /* -- None. -- */
  /* Task entry code END */

  /* Task code. */
  baseRateService(task);

  /* Task exit code BEGIN */
  /* -- None. -- */
  /* Task exit code END */
}

/* ===== Declarations of RTI blocks ======================================== */

/* dSPACE I/O Board DS1104SER #1 Unit:GENSER Group:SETUP */
dsserChannel *rtiDS1104SER_B1_Ser[1];

/* dSPACE Test-Automation Stimulus Engine */
#define TA_STIMULUS_ENGINE_ENABLE      0

/* ===== Definition of interface functions for simulation engine =========== */
#ifdef MULTITASKING
# define dsIsSampleHit(RTM,sti)        rtmGetSampleHitPtr(RTM)[sti]
#else
# define dsIsSampleHit(RTM,sti)        1
#endif

#if defined(_INLINE)
# define __INLINE                      static inline
#else
# define __INLINE                      static
#endif

static void rti_mdl_initialize_host_services(void)
{
  ts_timestamp_type ts = { 0, 0 };

  host_service(1, &ts);
}

static void rti_mdl_initialize_io_boards(void)
{
  /* Registering of RTI products and modules at VCM */
  {
    vcm_module_register(VCM_MID_RTI1104, (void *) 0,
                        VCM_TXT_RTI1104, 7, 0, 0,
                        VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);

    {
      vcm_module_descriptor_type* msg_mod_ptr;
      msg_mod_ptr = vcm_module_register(VCM_MID_MATLAB, (void *) 0,
        VCM_TXT_MATLAB, 8, 1, 0,
        VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_SIMULINK, msg_mod_ptr,
                          VCM_TXT_SIMULINK, 8, 1, 0,
                          VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_RTW, msg_mod_ptr,
                          VCM_TXT_RTW, 8, 4, 0,
                          VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_STATEFLOW, msg_mod_ptr,
                          VCM_TXT_STATEFLOW, 8, 1, 0,
                          VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
      vcm_module_register(VCM_MID_STATEFLOW_CODER, msg_mod_ptr,
                          VCM_TXT_STATEFLOW_CODER, 8, 4, 0,
                          VCM_VERSION_RELEASE, 0, 0, 0, VCM_CTRL_NO_ST);
    }
  }

  /* dSPACE I/O Board DS1104 #1 Unit:BIT_IO */
  ds1104_bit_io_init(DS1104_DIO1_OUT);

  /* Initialization of Master DAC units */
  ds1104_dac_init(DS1104_DACMODE_TRANSPARENT);
  ds1104_dac_trigger_setup(DS1104_TRIGGER_DISABLE);
}

static void rti_mdl_slave_load(void)
{
  /* dSPACE I/O Board DS1104SER #1 Unit:GENSER Group:SETUP */
  rtiDS1104SER_B1_Ser[0] = dsser_init(DSSER_ONBOARD,0,64);
  dsser_config(rtiDS1104SER_B1_Ser[0],0, 115200, 8, DSSER_1_STOPBIT,
               DSSER_NO_PARITY, DSSER_14_BYTE_TRIGGER_LEVEL,0, (DSSER_RS232 |
    DSSER_AUTOFLOW_DISABLE));
  RTLIB_SLAVE_LOAD_ACKNOWLEDGE();
}

/* Function rti_mdl_rtk_initialize() is empty */
#define rti_mdl_rtk_initialize()

static void rti_mdl_initialize_io_units(void)
{
  /* dSPACE I/O Board DS1104 #1 Unit:BIT_IO Group:BIT_OUT_CLEAR */
  ds1104_bit_io_clear(DS1104_DIO1);

  /* dSPACE I/O Board DS1104 #1 Unit:DAC */
  ds1104_dac_write(8, 0);

  /* dSPACE I/O Board DS1104SER #1 Unit:GENSER Group:SETUP */
  dsser_enable(rtiDS1104SER_B1_Ser[0]);
}

/* Function rti_mdl_acknowledge_interrupts() is empty */
#define rti_mdl_acknowledge_interrupts()

/* Function rti_mdl_timetables_register() is empty */
#define rti_mdl_timetables_register()

/* Function rti_mdl_timesync_simstate() is empty */
#define rti_mdl_timesync_simstate()

/* Function rti_mdl_timesync_baserate() is empty */
#define rti_mdl_timesync_baserate()

/* Function rti_mdl_background() is empty */
#define rti_mdl_background()

/* Function rti_mdl_sample_input() is empty */
#define rti_mdl_sample_input()

static void rti_mdl_daq_service()
{
  /* dSPACE Host Service */
  host_service(1, rtk_current_task_absolute_time_ptr_get());
}

#undef __INLINE

/****** [EOF] ****************************************************************/
